<?php

namespace jrosset\EnvReader\XmlStructure;

use SimpleXMLElement;

/**
 * Structure about a single attribute
 */
class AttributeSingleXmlStructure implements IXmlStructure {
    /**
     * @var string The attribute name
     */
    private string $attributeName;

    /**
     * Initialize
     *
     * @param string $attributeName The attribute name
     */
    public function __construct (string $attributeName) {
        $this->attributeName = $attributeName;
    }

    /**
     * @inheritDoc
     */
    public function parseXml (SimpleXMLElement $xmlNode): string {
        return (string)$xmlNode[$this->attributeName];
    }
}