<?php

namespace jrosset\EnvReader\XmlStructure;

use jrosset\Collections\InsensitiveCaseKeyCollection;
use SimpleXMLElement;

/**
 * Implementation for {@see AttributesXmlStructure} property
 */
trait TAttributeListXmlStructure {
    /**
     * @var AttributesXmlStructure|null The attribute structure. Null if none
     */
    private ?AttributesXmlStructure $attributesStructure = null;

    /**
     * Set the attribute structure
     *
     * @param AttributesXmlStructure|null $attributesStructure The new attribute structure. Null if none
     *
     * @return $this
     */
    public function setAttributesStructure (?AttributesXmlStructure $attributesStructure = null): static {
        $this->attributesStructure = $attributesStructure;
        return $this;
    }

    /**
     * Parse the attributes
     *
     * @param SimpleXMLElement $xmlNode The XML node
     *
     * @return mixed The extracted attributes
     */
    protected function parseXmlAttributes (SimpleXMLElement $xmlNode): InsensitiveCaseKeyCollection {
        if ($this->attributesStructure === null) {
            return new InsensitiveCaseKeyCollection();
        }

        return $this->attributesStructure->parseXml($xmlNode);
    }
}